////////////////////////////////////////////////////////////////////////////////
//                                 APICulture
//                        (c)  , 1999-2000
//    http://mazurkin.virtualave.net, mazurkin@mailru.com, mazurkin@chat.ru
// _____________________________________________________________________________
//                              
////////////////////////////////////////////////////////////////////////////////

unit AclThreadCalculus;

interface

uses Windows, Messages, WinLite;

const
  WM_EUREKA = WM_USER + 2;

type
  TThreadCalculus = class(TLiteThread)
  private
    FNoiseValue : Double;
    FWndNotify  : THandle;
    FTerminate  : Boolean;
  protected
    function    ThreadProcedure: DWord; override;
  public
    function    Terminate: DWord;
    constructor CreateSlaved(WndNotify: THandle);
  end;

implementation

////////////////////////////////////////////////////////////////////////////////
//  
////////////////////////////////////////////////////////////////////////////////
constructor TThreadCalculus.CreateSlaved(WndNotify: THandle);
begin
  inherited Create;
  //  
  FWndNotify := WndNotify;
  //   
  SetThreadPriority(ThrHandle, THREAD_PRIORITY_IDLE);
  //  
  ResumeThread(ThrHandle);
end;

////////////////////////////////////////////////////////////////////////////////
//  
////////////////////////////////////////////////////////////////////////////////
function TThreadCalculus.ThreadProcedure: DWord;
begin
  //     
  FNoiseValue := 0.8;
  //  
  while not FTerminate do
  begin
    //     
    FNoiseValue := 3.97364312345678*FNoiseValue*(1-FNoiseValue);
    //   
    if (0.314158 < FNoiseValue) and (FNoiseValue < 0.314159) then
      //        
      SendMessage(FWndNotify, WM_EUREKA, 0, 0);  
  end;
  //   
  Result := $12345678;
  //      
  FTerminate := False;
end;

////////////////////////////////////////////////////////////////////////////////
//   
////////////////////////////////////////////////////////////////////////////////
function TThreadCalculus.Terminate: DWord;
begin
  //    
  FTerminate := True;
  // ,   
  while FTerminate do Sleep(50);
  //   
  GetExitCodeThread(ThrHandle, Result);
end;

end.
